diff -Nur -Xfreecivdiff.ignore freeciv-cvs/doc/README.effects freeciv-patched/doc/README.effects
--- freeciv-cvs/doc/README.effects	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/doc/README.effects	2003-06-30 12:18:17.000000000 +0100
@@ -39,6 +39,10 @@
 "Food_Bonus"	- food production is increased by AMOUNT percent
 		  (all Food_Bonus' are summed before being applied)
 
+"Food_Pct"	- multiplies total food production by AMOUNT percent
+		  (applied after Food_Bonus; multiple effects are
+		  multiplicative)
+
 "Food_Inc_Tile"	- each worked tile that is already producing some
 		  food produces AMOUNT additional food
 
@@ -57,16 +61,35 @@
 "Luxury_Bonus"	- luxury production increased by AMOUNT percent
 		  (all Luxury_Bonus' are summed before being applied)
 
-"Luxury_Pct"	- increases luxury production by AMOUNT percent
-
-"Make_Content"	- makes AMOUNT unhappy citizens content
+"Luxury_Pct"	- multiplies luxury production by AMOUNT percent
+		  (applied after Luxury_Bonus; multiple effects
+		  are multiplicative)
 
-"Make_Content_Mil"- makes AMOUNT per unit of unhappy citizens caused
+"Make_Content_Mil"- makes AMOUNT unhappy citizens caused
 		  by units outside of a city content
 
-"Make_Content_Pct"- increase "Make_Content" by AMOUNT percent
+"Make_Content_Mil_Per"- makes AMOUNT _per unit_ of unhappy citizens
+		  caused by units outside of a city content
+
+"Make_Content"	- makes AMOUNT unhappy citizens content
+		  (applied *before* martial law and aggressive units;
+		  all Make_Content's are summed before being applied)
+
+"Make_Content_Pct"- multiplies total "Make_Content" by AMOUNT percent
+		  (multiple effects are multiplicative)
 
 "Make_Happy"	- makes AMOUNT content citizens happy
+		  (all Make_Happy's are summed before being applied)
+
+"Force_Content"	- makes AMOUNT unhappy citizens content
+		  (applied *after* martial law and aggressive units;
+		  all Force_Content's are summed before being applied)
+
+"Force_Content_Pct"- increase total "Force_Content" by AMOUNT percent
+		  (multiple effects are multiplicative)
+
+"Force_Happy"	- makes AMOUNT content citizens happy
+		  (all Force_Happy's are summed before being applied)
 
 "May_Declare_War"- allowed to declare war at least AMOUNT percent
 		  of the time
@@ -77,27 +100,28 @@
 
 "Nuke_Proof"	- nuclear attacks will fail within AMOUNT distance
 
-"Pollu_Adj"	- multiplies pollution by AMOUNT percent
+"Pollu_Adj"	- pollution is increased by AMOUNT percent
 		  (all Pollu_Adj's are summed before being applied)
 
-"Pollu_Adj_Pop"	- multiplies pollution caused by population by AMOUNT
-		  percent
-		  (all Pollu_Adj_Pop's are summed before being applied)
-
-"Pollu_Adj_Prod"- multiplies pollution caused by shield production by
-		  AMOUNT percent
-		  (all Pollu_Adj_Prod's are summed before being applied)
-
-"Pollu_Set"	- sets pollution to AMOUNT; override all other effects
-		  (all Pollu_Set's are summed before being applied)
-
-"Pollu_Set_Pop"	- sets pollution caused by population to AMOUNT;
-		  override all other effects
-		  (all Pollu_Set_Pop's are summed before being applied)
-
-"Pollu_Set_Prod"- sets pollution caused by shield production to AMOUNT;
-		  override all other effects
-		  (all Pollu_Set_Prod's are summed before being applied)
+"Pollu_Pct"	- multiplies pollution by AMOUNT percent
+		  (applied after Pollu_Adj; multiple effects
+		  are multiplicative)
+
+"Pollu_Pop_Adj"	- pollution caused by population is increased by
+		  AMOUNT percent (all Pollu_Pop_Adj's are summed
+		  before being applied)
+
+"Pollu_Pop_Pct"	- multiplies pollution caused by population by
+		  AMOUNT percent (applied after Pollu_Pop_Adj;
+		  multiple effects are multiplicative)
+
+"Pollu_Prod_Adj"- pollution caused by shield production is increased by
+		  AMOUNT percent (all Pollu_Prod_Adj's are summed
+		  before being applied)
+
+"Pollu_Prod_Pct"- multiplies pollution caused by shield production by
+		  AMOUNT percent (applied after Pollu_Prod_Adj;
+		  multiple effects are multiplicative)
 
 "Prod_Add_Tile"	- each worked tile produces AMOUNT additional shield
 		  production
@@ -105,6 +129,10 @@
 "Prod_Bonus"	- shield production is increased by AMOUNT percent
 		  (all Prod_Bonus' are summed before being applied)
 
+"Prod_Pct"	- multiplies total shield production by AMOUNT percent
+		  (applied after Prod_Bonus; multiple effects are
+		  multiplicative)
+
 "Prod_Inc_Tile"	- each worked tile that is already producing some
 		  shields produces AMOUNT additional shields
 
@@ -113,21 +141,32 @@
 
 "Prod_To_Gold"	- convert production to gold at AMOUNT percent rate
 
-"Reduce_Corrupt"- reduces corruption by AMOUNT percent
+"Corrupt_Adj"	- corruption is increased by AMOUNT percent
+		  (all Corrupt_Adj's are summed before being applied)
 
-"Reduce_Waste"	- reduces waste by AMOUNT percent
+"Corrupt_Pct"	- multiplies total corruption by AMOUNT percent
+		  (applied after Corrupt_Adj; multiple effects are
+		  multiplicative)
 
 "Reveal_Cities"	- make all city tiles known
 
 "Reveal_Map"	- make entire map known
 
-"Revolt_Dist"	- multiplies effective distance to the capital by
+"Revolt_Dist_Adj"- effective distance to the capital is increased by
+		  AMOUNT percent for purpose of computing revolt cost
+		  (all Revolt_Dist_Adj's are summed before being applied)
+
+"Revolt_Dist_Pct"- multiplies effective distance to the capital by
 		  AMOUNT percent for purpose of computing revolt cost
+		  (applied after Revolt_Dist_Adj; multiple effects are
+		  multiplicative)
 
 "Science_Bonus"	- science research is increased by AMOUNT percent
 		  (all Science_Bonus' are summed before being applied)
 
-"Science_Pct"	- increases science research by AMOUNT percent
+"Science_Pct"	- multiplies total science by AMOUNT percent
+		  (applied after Science_Bonus; multiple effects are
+		  multiplicative)
 
 "Size_Unlimit"	- cities not affected will not grow beyond AMOUNT
 
@@ -150,13 +189,19 @@
 "Tax_Bonus"	- tax revenues are increased by AMOUNT percent
 		  (all Tax_Bonus' are summed before being applied)
 
-"Tax_Pct"	- increases tax revenues by AMOUNT percent
+"Tax_Pct"	- multiplies total tax by AMOUNT percent
+		  (applied after Tax_Bonus; multiple effects are
+		  multiplicative)
 
 "Trade_Add_Tile"- each worked tile produces AMOUNT additional trade
 
 "Trade_Bonus"	- trade generated is increased by AMOUNT percent
 		  (all Trade_Bonus' are summed before being applied)
 
+"Trade_Pct"	- multiplies total trade by AMOUNT percent
+		  (applied after Trade_Bonus; multiple effects are
+		  multiplicative)
+
 "Trade_Inc_Tile"- each worked tile that is already producing some
 		  trade produces AMOUNT additional trade
 
@@ -166,7 +211,19 @@
 "Trade_Route_Pct"- increases trade from trade routes by AMOUNT percent
 
 "Unit_Defend"	- multiplies defense by AMOUNT percent against units
-		  of class .aff_unit
+		  of class .aff_unit (multiple effects are
+		  multiplicative)
+
+"Unit_Attack"	- multiplies attack by AMOUNT percent against units
+		  of class .aff_unit (multiple effects are multiplicative)
+
+"Unit_Attack_Firepower"- multiplies firepower by AMOUNT percent
+		  when attacking units of class .aff_unit (multiple
+		  effects are multiplicative)
+
+"Unit_Defend_Firepower"- multiplies firepower by AMOUNT percent
+		  when defending against units of class .aff_unit
+		  (multiple effects are multiplicative)
 
 "Unit_Move"	- adds AMOUNT of movement points to units of class
 		  .aff_unit
@@ -187,6 +244,22 @@
 "Unit_Veteran"	- all units of class .aff_unit produced are veteran
 		  units
 
+"Unit_Cost"	- increase the cost of building a unit of class
+		  .aff_unit in the city by AMOUNT percent
+		  (multiple effects are additive)
+
+"Building_Cost"	- increase the cost of building an improvement
+		  in the city by AMOUNT percent
+		  (multiple effects are additive)
+
+"Unit_Cost_Pct"	- multiply the cost of building a unit of class
+		  .aff_unit in the city by AMOUNT percent
+		  (multiple effects are multiplicative)
+
+"Building_Cost_Pct"- multiply the cost of building an improvement
+		  in the city by AMOUNT percent
+		  (multiple effects are multiplicative)
+
 "Upgrade_One_Step"- upgrade one obsolete unit per turn, stepping to each
 		  intermediate type; chance to upgrade each unit is
 		  AMOUNT percent
@@ -213,7 +286,17 @@
 	    (must be in the range -32767 to 32767)
 .survives  = 1 if effect survives destruction (wonders only)
 	    (if unspecified, 0 (doesn't survive) is assumed)
-.cond_bldg = must have this building in same city for effect
+.outside   = 1 if, for effects at greater than City-range, the effect
+	     is active in all tiles, not just the city center. For tax
+	     and science city bonuses, this means that the TOTAL science
+	     output of all cities affected is subject to the bonus,
+	     rather than the output of each city individually.
+	     Applicable effects: Science_Bonus, Science_Pct,
+	     Tax_Bonus, Tax_Pct, Unit_Defend, Unit_Attack,
+	     Unit_Attack_Firepower, Unit_Defend_Firepower,
+	     Unit_Recover, Unit_Vet_Combat, Upgrade_*
+	    (if unspecified, 0 (city center only) is assumed)
+.cond_bldg = effect is only active in cities that have this building
 	    (if unspecified, effect not conditional on building)
 .cond_nat  = must be this nation for effect
                    (if unspecified, effect not conditional on nation)
@@ -221,10 +304,12 @@
 	    (if unspecified, effect not conditional on government)
 .cond_adv  = must know this advance for effect
 	    (if unspecified, effect not conditional on advance)
-.cond_eff  = must be affected by this effect for effect
+.cond_eff  = the improvement conferring the effect must in turn be
+	     first affected by the given effect
 	    (if unspecified, effect not conditional on other effect)
 .aff_unit  = affects only those units of this class; one of:
-             "Air", "Helicopter", "Land", "Missile", "Nuclear", "Sea"
+             "Air", "Heli", "Land", "Missile", "Nuclear", "Sea",
+	     a unit flag, or a class defined in units.ruleset
 	    (if unspecified, may affect units of all classes)
 .aff_terr  = affects only those squares of this terrain type
 	    (if unspecified, may affect all squares; if "None",
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/doc/README.impr-gen freeciv-patched/doc/README.impr-gen
--- freeciv-cvs/doc/README.impr-gen	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/doc/README.impr-gen	2003-06-30 12:17:12.000000000 +0100
@@ -0,0 +1,162 @@
+----------------------------------------------------------------------
+                       Generalised improvements
+----------------------------------------------------------------------
+               Ben Webb, ben@bellatrix.pcl.ox.ac.uk
+
+Overview
+--------
+ Freeciv uses rulesets to configure much of its behaviour (see
+ README.rulesets). However, what is not immediately apparent is that
+ the ruleset for city improvements is not as flexible as it would
+ appear; you cannot change the total number of buildings, for example,
+ and even if you change the name or stated behaviour of a building,
+ it will still function as before (for example, the first building
+ will always act as an Airport, no matter what you do). The minor
+ differences in building behaviour between CivI and CivII are
+ accommodated by means of the "variant" option, which again has a
+ fixed effect in the Freeciv code.
+
+ Generalised improvements aims to eliminate this problem, to allow
+ modpack and ruleset writers much greater flexibility. A major drive
+ in the code development was support for alternative Civ-like games
+ such as Alpha Centauri and Call To Power, which have radically
+ different sets of buildings and effects.
+
+Rulesets
+--------
+ With generalised improvements, you must specify what effect each
+ building has by filling in the "effect" field.
+ data/default/buildings.ruleset lists the valid values for this field,
+ and supplies suitable values for standard Freeciv behaviour, so it
+ should be straightforward to modify this for your own buildings. There
+ are, however, a number of caveats:
+
+ - The AI does not yet understand generalised improvements, so will
+   get very upset if you change things too radically. However, this
+   will shortly be remedied.
+
+ - Any effect, from any building, can have a "World" range - i.e. it
+   affects every city and every unit in the game. Players, however, can
+   usually only see the buildings in their own cities, plus any Wonders,
+   so World-range effects for ordinary buildings can cause confusion
+   (since a player won't know _why_ his/her cities are under a particular
+   effect). It is therefore recommeded that you only use World-range
+   effects for Wonders.
+
+ - Island-range effects affect every city and unit on the same island as
+   the building which confers the effect. However, players' ideas of what
+   constitutes an "island" can differ from the server, since they only
+   know part of the map (for instance, say you have discovered the southern
+   tips of two islands, but don't yet know whether they are linked by a
+   land bridge). This can also cause confusion, and so Island-range effects
+   are best treated with caution until this difference between client and
+   server is remedied in Freeciv.
+
+ - Some effects do not have a defined "range" (and the range field will be
+   ignored even if you supply it). These are Adv_Parasite, Have_Embassies,
+   Reveal_Cities, Reveal_Map, No_Anarchy, Any_Government and Give_Imm_Adv.
+
+ - Not all effects are currently implemented:
+   - Enemy_Peaceful, Improve_Rep and May_Declare_War involve diplomacy,
+     which is not yet fully supported by Freeciv.
+   - Barb_Attack, Barb_Defend, Slow_Nuke_Winter, Slow_Global_Warm and
+     Trade_Route_Pct are not yet coded for, but are not used in standard
+     Freeciv rulesets anyway.
+   - I'm not sure what Capital_Exists was intended to do...
+
+ - Although effects with the "survives" field set persist even if the Wonder
+   that originally conferred them is destroyed (e.g. the Apollo or Manhattan
+   Wonders in the default ruleset) the client may lose track of these effects
+   if the game is saved and then reloaded.
+
+Non-building effects
+--------------------
+ impr-gen effects were originally designed for implementing the behaviour of
+ city improvements. However, the system has proved flexible enough to be able
+ to describe the effects of other game entities as well. To date, units,
+ governments and nations can all use impr-gen effects. It is simple to add
+ these effects - just add an effects field to the relevant unit, government
+ or nation in the ruleset, in exactly the same way as it's done in
+ buildings.ruleset. Note, however, that:
+
+ - "range" has no meaning for effects in units.ruleset. All effects are
+   assumed to act only on the unit itself. This may be expanded in future.
+
+ - Nation and government effects can only specify the ranges "Player" and
+   "World".
+
+ - Many effects make little sense in units.ruleset; you are largely
+   restricted to the various Unit_xxx effects.
+
+Code
+----
+ The bulk of the generalised improvements code is located in
+ common/improvement.c and common/game.c. This takes care of making lists
+ of all active effects, which can then be iterated over elsewhere in the
+ code when effects are required. All effects generated by a city's
+ improvements are stored in pcity->effects, which is a list of eff_city
+ structures. To save on having to iterate over all cities affected by a
+ given effect, effects that have Island-, Player-, or World- range are 
+ also copied into lists of eff_global structures (which are derived from
+ eff_city, with a city ID added) which are stored as
+ pplayer->island_effects, pplayer->effects, and game.effects
+ respectively. (For the purpose of considering the "equiv_range"
+ behaviour of buildings, similar lists of buildings are also
+ maintained, as pplayer->island_improv, pplayer->improvements, and
+ game.improvements, respectively.)
+
+ When buildings are built, moved, or destroyed, their effects can also
+ change. Since buildings can deactivate other buildings (e.g. the Great
+ Wall wonder renders all City Walls redundant in the default ruleset)
+ while effects can have dependencies, including depending on other
+ effects, whenever this occurs all effects are updated by calling
+ update_all_effects(). Since this scales as O(N**2) with the number
+ of cities in the game, this function (and all calls to it) are prime
+ targets for optimisation. The update_all_effects() function marks
+ buildings as active, obsolete (due to tech advances) or redundant
+ (replaced by another building, via. equiv_repl/equiv_dupl) and also
+ marks which effects of the active buildings are themselves active.
+ Effects that can also dependent on terrain/special type, or other
+ buildings, must be explicitly tested for activation when they are
+ used (but the effect iterators - see below - handle this automatically).
+
+ Effects of buildings that do not yet exist (for example, during AI
+ calculations) will not be activated. Thus, the is_effect_activated,
+ is_city_affected and is_unit_terrain_affected functions must be
+ called in this case to ascertain whether an effect is active. (Bear
+ in mind, however, that this may still be inaccurate, as another
+ effect may depend on this effect, and so will not be properly
+ activated without a call to update_all_effects).
+
+ A number of functions and macros are provided for iterating over all
+ active effects. The eff_iterator_impr_init() function is used for
+ considering all effects that affect a given building in a given city,
+ owned by a given player (although arguments can be ommitted, so for
+ example, it could be used to only look at Player-range effects by
+ passing a NULL city pointer). The impr_effects_iterate and
+ city_effects_iterate macros are useful shortcuts for calling these
+ functions (the city_ variants assume that the player is the owner of
+ the city, and that no specific building in the city is targetted).
+ Additional macros ending in _full allow the terrain type of the city
+ tile to be overridden with passed values, e.g. for considering worked
+ tiles outside the city centre. eff_iterator_unit_init() considers
+ effects that influence a unit at given map coordinates, which may or
+ may not be within a city, and the unit_effects_iterate macro is a
+ useful shortcut.
+
+ Older Freeciv code simply checked the current city's list of buildings
+ and the global list of Wonders; for instance, when calculating defence
+ strength, it simply needed to test if the current city had the City Walls
+ building, and if the current player owned the Great Wall Wonder. This
+ is extremely fast when compared to iterating over a list of multiple
+ effects at several ranges, particularly as many such lookups are typically
+ performed for each city and unit during the game. Thus, the aim is to
+ reduce the number of effect iterations as much as possible, storing
+ intermediate data in various game structures. For instance, the
+ calculation of city bonuses, happiness, and pollution modifiers is all
+ rolled into one effect iteration (in common/city.c).
+
+Credits
+-------
+ - Code: Ben Webb <ben@bellatrix.pcl.ox.ac.uk>
+ - Bug fixes and ruleset tweaks: Davide Pagnin <nightmare@freeciv.it>
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/doc/README.rulesets freeciv-patched/doc/README.rulesets
--- freeciv-cvs/doc/README.rulesets	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/doc/README.rulesets	2003-06-30 12:17:12.000000000 +0100
@@ -108,6 +108,10 @@
   "TODO Variants" section below for which variant effects which have
   been implemented so far.
 
+- Please note: the rulesets for buildings (city improvements) are currently
+  in the process of being generalised. Thus, some or all of the documentation
+  here will be out of date - see README.impr-gen for more details.
+
 - Units have a new field, "roles", which is like "flags", but 
   determines which units are used in various circumstances of the
   game (rather than intrinsic properties of the unit).
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/citytools.c freeciv-patched/server/citytools.c
--- freeciv-cvs/server/citytools.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/server/citytools.c	2003-06-30 12:18:03.000000000 +0100
@@ -510,15 +510,18 @@
 **************************************************************************/
 bool do_make_unit_veteran(struct city *pcity, Unit_Type_id id)
 {
-  if (unit_type_flag(id, F_DIPLOMAT))
-    return government_has_flag(get_gov_pcity(pcity), G_BUILD_VETERAN_DIPLOMAT);
+  struct map_position mappos;
 
-  if (is_ground_unittype(id) || improvement_variant(B_BARRACKS)==1)
-    return city_got_barracks(pcity);
-  else if (is_water_unit(id))
-    return (city_affected_by_wonder(pcity, B_LIGHTHOUSE) || city_got_building(pcity, B_PORT));
-  else
-    return city_got_building(pcity, B_AIRPORT);
+  mappos.x = pcity->x;
+  mappos.y = pcity->y;
+  /* Do we have any veteran-making effects? */
+  unittype_effects_iterate(iter, id, id, city_owner(pcity), &mappos) {
+    if (iter.imeff->type == EFT_UNIT_VETERAN) {
+      return TRUE;
+    }
+  } unittype_effects_iterate_end;
+
+  return FALSE;
 }
 
 /**************************************************************************
@@ -550,14 +553,14 @@
 **************************************************************************/
 bool wants_to_be_bigger(struct city *pcity)
 {
-  if (pcity->size < game.aqueduct_size) return TRUE;
-  if (city_got_building(pcity, B_SEWER)) return TRUE;
-  if (city_got_building(pcity, B_AQUEDUCT)
-      && pcity->size < game.sewer_size) return TRUE;
-  if (!pcity->is_building_unit) {
-    if (pcity->currently_building == B_SEWER && pcity->did_buy) return TRUE;
-    if (pcity->currently_building == B_AQUEDUCT && pcity->did_buy) return TRUE;
-  } /* saves a lot of stupid flipflops -- Syela */
+  if (pcity->size_limit < 0) return TRUE;  /* No size restriction */
+  if (pcity->size < pcity->size_limit) return TRUE;
+
+  /* saves a lot of stupid flipflops -- Syela */
+  if (!pcity->is_building_unit
+      && pcity->currently_building == pcity->unlimit_impr
+      && pcity->did_buy) return TRUE;
+
   return FALSE;
 }
 
@@ -826,7 +829,7 @@
      then restore the local improvement list - we need this to restore the
      global effects for the new city owner) */
   built_impr_iterate(pcity, i) {
-    city_remove_improvement(pcity, i);
+    city_remove_improvement(pcity, i, FALSE);
     pcity->improvements[i] = I_ACTIVE;
   } built_impr_iterate_end;
 
@@ -970,19 +973,21 @@
   pcity->id = get_next_id_number();
   idex_register_city(pcity);
 
-  if (!pplayer->capital) {
-    pplayer->capital = TRUE;
-    city_add_improvement(pcity, B_PALACE);
-  }
-
   /* Before arranging workers to show unknown land */
   map_unfog_pseudo_city_area(pplayer, x, y);
 
   map_set_city(x, y, pcity);
 
   city_list_insert(&pplayer->cities, pcity);
+  if (!pplayer->capital) {
+    pplayer->capital = TRUE;
+    city_add_improvement(pcity, B_PALACE);
+    update_all_effects();
+  }
   add_city_to_minimap(x, y);
 
+  update_city_bonuses(pcity);
+
   /* it is possible to build a city on a tile that is already worked
    * this will displace the worker on the newly-built city's tile -- Syela */
   for (y_itr = 0; y_itr < CITY_MAP_SIZE; y_itr++) {
@@ -1057,7 +1062,7 @@
 
   built_impr_iterate(pcity, i) {
     effect_update = TRUE;
-    city_remove_improvement(pcity, i);
+    city_remove_improvement(pcity, i, TRUE);
   } built_impr_iterate_end;
 
   /* This is cutpasted with modifications from transfer_city_units. Yes, it is ugly.
@@ -1557,6 +1562,9 @@
   packet->pollution=pcity->pollution;
 
   packet->city_options=pcity->city_options;
+
+  packet->buildflags = pcity->buildflags;
+  packet->upkeep_free = pcity->upkeep_free;
   
   packet->is_building_unit=pcity->is_building_unit;
   packet->currently_building=pcity->currently_building;
@@ -1708,6 +1716,7 @@
   if (!is_wonder(id)) {
     pplayer->economic.gold += improvement_value(id);
     building_lost(pcity, id);
+    update_all_effects();
   }
 }
 
@@ -1718,7 +1727,7 @@
 {
   struct player *owner = city_owner(pcity);
 
-  city_remove_improvement(pcity,id);
+  city_remove_improvement(pcity, id, FALSE);
   if (id == B_PALACE &&
       ((owner->spaceship.state == SSHIP_STARTED) ||
        (owner->spaceship.state == SSHIP_LAUNCHED))) {
